diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/PersistentTermInitializer.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/PersistentTermInitializer.java
index 6cb8e8819d..65af320027 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/PersistentTermInitializer.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/PersistentTermInitializer.java
@@ -91,6 +91,17 @@ public class PersistentTermInitializer extends DefaultTermInitializer {
     @Override
     public void doInitialize(){
         logger.info("PersistentTermInitializer initialize start ...");
+        
+//        //only for testing - remove
+//        TransactionStatus txStatus2 = transactionManager.getTransaction(txDefinition);
+//        int i = vocabularyDao.count();
+//        List<TermVocabulary> list = vocabularyDao.list(null, null);
+//        for (TermVocabulary voc : list){
+//        	System.out.println(voc.getUuid());
+//        }
+//        transactionManager.commit(txStatus2);
+//        // end testing
+        
         if (omit){
             logger.info("PersistentTermInitializer.omit == true, returning without initializing terms");
             return;
@@ -99,6 +110,7 @@ public class PersistentTermInitializer extends DefaultTermInitializer {
             logger.info("PersistentTermInitializer.omit == false, initializing " + VocabularyEnum.values().length + " term classes");
 
             TransactionStatus txStatus = transactionManager.getTransaction(txDefinition);
+//          TermVocabulary v = vocabularyDao.findByUuid(UUID.fromString("45ac7043-7f5e-4f37-92f2-3874aaaef2de"));
             for(VocabularyEnum vocabularyType : VocabularyEnum.values()) {
                 //Class<? extends DefinedTermBase<?>> clazz = vocabularyType.getClazz();
                 UUID vocabularyUuid = firstPass(vocabularyType,terms);
@@ -120,11 +132,11 @@ public class PersistentTermInitializer extends DefaultTermInitializer {
     protected void secondPass(Class clazz, UUID vocabularyUuid, Map<UUID,DefinedTermBase> terms) {
         logger.debug("Initializing vocabulary for class " + clazz.getSimpleName() + " with uuid " + vocabularyUuid );
 
-        TermVocabulary persistedVocabulary = vocabularyDao.findByUuid(vocabularyUuid);
+        TermVocabulary<?> persistedVocabulary = vocabularyDao.findByUuid(vocabularyUuid);
 
         if (persistedVocabulary != null){
             for(Object object : persistedVocabulary.getTerms()) {
-                DefinedTermBase definedTermBase = (DefinedTermBase) object;
+                DefinedTermBase<?> definedTermBase = (DefinedTermBase) object;
                 Hibernate.initialize(definedTermBase.getRepresentations());
                 for(Representation r : definedTermBase.getRepresentations()) {
                     Hibernate.initialize(r.getLanguage());
@@ -133,7 +145,7 @@ public class PersistentTermInitializer extends DefaultTermInitializer {
             }
         }else{
             logger.error("Persisted Vocabulary does not exist in database: " + vocabularyUuid);
-            throw new NullPointerException("Persisted Vocabulary does not exist in database: " + vocabularyUuid);
+            throw new IllegalStateException("Persisted Vocabulary does not exist in database: " + vocabularyUuid);
         }
         logger.debug("Setting defined Terms for class " + clazz.getSimpleName() + ", " + persistedVocabulary.getTerms().size() + " in vocabulary");
         super.setDefinedTerms(clazz, persistedVocabulary);
@@ -157,18 +169,18 @@ public class PersistentTermInitializer extends DefaultTermInitializer {
             terms.put(d.getUuid(), d);
         }
 
-        TermVocabulary loadedVocabulary  = termLoader.loadTerms(vocabularyType, terms);
+        TermVocabulary<?> loadedVocabulary  = termLoader.loadTerms(vocabularyType, terms);
 
         UUID vocabularyUuid = loadedVocabulary.getUuid();
 
 
         logger.debug("loading vocabulary " + vocabularyUuid);
-        TermVocabulary persistedVocabulary = vocabularyDao.findByUuid(vocabularyUuid);
+        TermVocabulary<DefinedTermBase> persistedVocabulary = vocabularyDao.findByUuid(vocabularyUuid);
         if(persistedVocabulary == null) { // i.e. there is no persisted vocabulary
             logger.debug("vocabulary " + vocabularyUuid + " does not exist - saving");
             saveVocabulary(loadedVocabulary);
         }else {
-            logger.debug("vocabulary " + vocabularyUuid + " does exist and already has " + persistedVocabulary.size() + " terms");
+            if (logger.isDebugEnabled()){logger.debug("vocabulary " + vocabularyUuid + " does exist and already has " + persistedVocabulary.size() + " terms");}
             boolean persistedVocabularyHasMissingTerms = false;
             for(Object t : loadedVocabulary.getTerms()) {
                 if(!persistedVocabulary.getTerms().contains(t)) {
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/DatabaseTypeBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/DatabaseTypeBase.java
index 63fcf43c82..848e8634f8 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/DatabaseTypeBase.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/DatabaseTypeBase.java
@@ -12,6 +12,7 @@ package eu.etaxonomy.cdm.database.types;
 import javax.sql.DataSource;
 
 import org.apache.log4j.Logger;
+import org.hibernate.dialect.Dialect;
 
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 import eu.etaxonomy.cdm.database.NomenclaturalCodeAwareDataSource;
@@ -33,7 +34,7 @@ abstract class DatabaseTypeBase implements IDatabaseType {
 	//defaultPort
 	private int defaultPort;
 	//hibernate dialect
-	private String hibernateDialect;
+	private Dialect hibernateDialect;
 	//init method
 	private String initMethod = null;
 	//init method
@@ -41,7 +42,7 @@ abstract class DatabaseTypeBase implements IDatabaseType {
 	
 	
 	//init
-	protected void init(String typeName, String classString, String urlString, int defaultPort, String hibernateDialect) {
+	protected void init(String typeName, String classString, String urlString, int defaultPort, Dialect hibernateDialect) {
 		this.typeName = typeName;
 		this.classString = classString;
 		this.urlString = urlString;
@@ -49,43 +50,37 @@ abstract class DatabaseTypeBase implements IDatabaseType {
 		this.hibernateDialect = hibernateDialect;
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.IDatabaseType#getName()
-	 */
+	@Override
 	public String getName(){
 		return typeName;
 	}
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.IDatabaseType#getClassString()
-	 */
+
+	@Override
 	public String getClassString(){
 		return classString;
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.IDatabaseType#getUrlString()
-	 */
+	@Override
 	public String getUrlString(){
 		return urlString;
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.IDatabaseType#getDefaultPort()
-	 */
+	@Override
 	public int getDefaultPort(){
 		return defaultPort;
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.IDatabaseType#getHibernateDialect()
-	 */
-	public String getHibernateDialect(){
-		return "org.hibernate.dialect." + hibernateDialect;
+	@Override
+	public Dialect getHibernateDialect(){
+		return hibernateDialect;
 	}
-	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.IDatabaseType#getConnectionString(java.lang.String, java.lang.String)
-	 */
+
+	@Override
+	public String getHibernateDialectCanonicalName(){
+		return hibernateDialect.getClass().getCanonicalName();
+	}
+
+	@Override
 	public String getConnectionString(ICdmDataSource cdmDataSource){
 		int port = cdmDataSource.getPort();
 		if (port< 1){
@@ -96,30 +91,22 @@ abstract class DatabaseTypeBase implements IDatabaseType {
 	
 	abstract protected String getConnectionString(ICdmDataSource cdmDataSource, int port);
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.types.IDatabaseType#getDataSourceClass()
-	 */
+	@Override
 	public Class<? extends DataSource> getDataSourceClass() {
 		return NomenclaturalCodeAwareDataSource.class;
 	} 
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.types.IDatabaseType#getInitMethod()
-	 */
+	@Override
 	public String getInitMethod() {
 		return initMethod;
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.types.IDatabaseType#getDestroyMethod()
-	 */
+	@Override
 	public String getDestroyMethod() {
 		return destroyMethod;
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.types.IDatabaseType#getServerNameByConnectionString(java.lang.String)
-	 */
+	@Override
 	public String getServerNameByConnectionString(String connectionString){
     	return getServerNameByConnectionString(connectionString, urlString, "/");
     }
@@ -143,9 +130,7 @@ abstract class DatabaseTypeBase implements IDatabaseType {
     	return result;
     }
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.types.IDatabaseType#getPortByConnectionString(java.lang.String)
-	 */
+	@Override
 	public int getPortByConnectionString(String connectionString){
 		String dbSeparator = "/";
     	return getPortByConnectionString(connectionString, urlString, dbSeparator);
@@ -195,9 +180,7 @@ abstract class DatabaseTypeBase implements IDatabaseType {
     	return result;
     }
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.types.IDatabaseType#getDatabaseNameByConnectionString(java.lang.String)
-	 */
+	@Override
 	public abstract String getDatabaseNameByConnectionString(String connectionString);
 
 	
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/Db2DatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/Db2DatabaseType.java
index d793f1a93c..7ffa566fbc 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/Db2DatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/Db2DatabaseType.java
@@ -9,6 +9,9 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.DB2Dialect;
+import org.hibernate.dialect.Dialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
 
@@ -33,7 +36,7 @@ public class Db2DatabaseType extends DatabaseTypeBase {
     //port
     private int defaultPort = 50000;
     //hibernate dialect
-    private String hibernateDialect = "DB2Dialect";
+    private Dialect hibernateDialect = new DB2Dialect();
 
     private static String dbSeparator = "/";
     
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/H2DatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/H2DatabaseType.java
index cd520dbbb8..90e3394e31 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/H2DatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/H2DatabaseType.java
@@ -15,6 +15,8 @@ import java.io.IOException;
 import javax.sql.DataSource;
 
 import org.apache.log4j.Logger;
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.H2CorrectedDialect;
 
 import eu.etaxonomy.cdm.api.application.CdmApplicationUtils;
 import eu.etaxonomy.cdm.database.H2Mode;
@@ -46,7 +48,7 @@ public class H2DatabaseType extends DatabaseTypeBase {
     private int defaultPort = 9092;
     
     //hibernate dialect
-    private String hibernateDialect = "H2CorrectedDialect";
+    private Dialect hibernateDialect = new H2CorrectedDialect();
     
     //init method
     private String initMethod = "init";
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/HSqlDbDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/HSqlDbDatabaseType.java
index b948d690e7..2c531a9d48 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/HSqlDbDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/HSqlDbDatabaseType.java
@@ -11,6 +11,9 @@ package eu.etaxonomy.cdm.database.types;
 
 import javax.sql.DataSource;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.HSQLCorrectedDialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 import eu.etaxonomy.cdm.database.LocalHsqldb;
 
@@ -34,7 +37,7 @@ public class HSqlDbDatabaseType extends DatabaseTypeBase {
     private int defaultPort = 9001;
     
     //hibernate dialect
-    private String hibernateDialect = "HSQLCorrectedDialect";
+    private Dialect hibernateDialect = new HSQLCorrectedDialect();
     
     //init method
     private String initMethod = "init";
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/IDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/IDatabaseType.java
index dc70b8eab9..618c2900dd 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/IDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/IDatabaseType.java
@@ -11,6 +11,8 @@ package eu.etaxonomy.cdm.database.types;
 
 import javax.sql.DataSource;
 
+import org.hibernate.dialect.Dialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
 /**
@@ -37,9 +39,16 @@ public interface IDatabaseType {
 	public int getDefaultPort();
 	
 	/**
+	 * Returns the {@link Dialect hibernate dialect}
+	 * @return
+	 */
+	public Dialect getHibernateDialect();
+	
+	/**
+	 * Returns the canoncial (full path) name of the {@link Dialect hibernate dialect} class
 	 * @return
 	 */
-	public String getHibernateDialect();
+	public String getHibernateDialectCanonicalName();
 	
 	/**
 	 * Returns the connection String for the given parameters, using default port
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/MySQLDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/MySQLDatabaseType.java
index 20f351163e..32f8dccfea 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/MySQLDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/MySQLDatabaseType.java
@@ -9,6 +9,9 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.H2CorrectedDialect;
+import org.hibernate.dialect.MySQL5InnoDBUtf8Dialect;
 import org.hibernate.dialect.MySQL5MyISAMUtf8Dialect;
 
 import eu.etaxonomy.cdm.database.ICdmDataSource;
@@ -35,10 +38,9 @@ public class MySQLDatabaseType extends DatabaseTypeBase {
     private static String dbSeparator = "/";
 
     //hibernate dialect
-    // TODO switch to MySQLInnoDBUtf8Dialect !!
     // see #3371 (switch cdm to MySQL InnoDB)
-    //private String hibernateDialect = MySQLInnoDBUtf8Dialect.class.getSimpleName();
-    private final String hibernateDialect = MySQL5MyISAMUtf8Dialect.class.getSimpleName();
+    private Dialect hibernateDialect = new MySQL5InnoDBUtf8Dialect();
+//    private Dialect hibernateDialect = MySQL5MyISAMUtf8Dialect.getDialect();
 
     //connection String
 	@Override
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OdbcDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OdbcDatabaseType.java
index 0be8063abb..00d2897b66 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OdbcDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OdbcDatabaseType.java
@@ -9,6 +9,8 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.Dialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
 
@@ -34,7 +36,7 @@ public class OdbcDatabaseType extends DatabaseTypeBase {
     
     //hibernate dialect
     //TODO
-    private String hibernateDialect = "xxx";
+    private Dialect hibernateDialect = null;
     
     //connection String
 	public String getConnectionString(ICdmDataSource ds, int port){
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OracleDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OracleDatabaseType.java
index 0527cbdcfb..fa3d31805d 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OracleDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/OracleDatabaseType.java
@@ -9,6 +9,9 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.Oracle10gDialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
 
@@ -27,7 +30,7 @@ public class OracleDatabaseType extends DatabaseTypeBase {
     //port
     private int defaultPort = 1521;
     //hibernate dialect
-    private String hibernateDialect = "OracleDialect";
+    private Dialect hibernateDialect = new Oracle10gDialect();
 
     private String dbSeparator = ":";
     
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/PostgreSQLDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/PostgreSQLDatabaseType.java
index b0fd8c8daf..05b3677357 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/PostgreSQLDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/PostgreSQLDatabaseType.java
@@ -9,6 +9,9 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.PostgreSQL82Dialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
 
@@ -27,7 +30,7 @@ public class PostgreSQLDatabaseType extends DatabaseTypeBase {
     //port
     private int defaultPort = 5432;
     //hibernate dialect
-    private String hibernateDialect = "PostgreSQLDialect";
+    private Dialect hibernateDialect = new PostgreSQL82Dialect();
 
     private static String dbSeparator = "/";
     
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2005DatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2005DatabaseType.java
index 3ffc33d377..d0c2a96d9b 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2005DatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2005DatabaseType.java
@@ -12,6 +12,9 @@ package eu.etaxonomy.cdm.database.types;
 import java.sql.ResultSet;
 import java.sql.SQLException;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.SQLServer2005Dialect;
+
 import eu.etaxonomy.cdm.database.CdmDataSource;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
@@ -37,7 +40,7 @@ public class SqlServer2005DatabaseType extends DatabaseTypeBase {
     protected int defaultPort = 1433;
     
     //hibernate dialect
-    protected String hibernateDialect = "SQLServer2005Dialect";
+    protected Dialect hibernateDialect = new SQLServer2005Dialect();
  
     public String getConnectionString(ICdmDataSource ds, int port){
     	return getConnectionString(ds, port, null);
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2008DatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2008DatabaseType.java
index 0088a7753d..00330a503d 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2008DatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SqlServer2008DatabaseType.java
@@ -9,6 +9,9 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.SQLServer2008Dialect;
+
 
 
 /**
@@ -18,7 +21,7 @@ package eu.etaxonomy.cdm.database.types;
 public class SqlServer2008DatabaseType extends SqlServer2005DatabaseType {
     
     //hibernate dialect
-    protected String hibernateDialect = "SQLServer2008Dialect" ;
+    protected Dialect hibernateDialect = new SQLServer2008Dialect();
     
 	
 	//Constructor
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SybaseDatabaseType.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SybaseDatabaseType.java
index ba18466852..a9c4346da1 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SybaseDatabaseType.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/types/SybaseDatabaseType.java
@@ -9,6 +9,9 @@
 
 package eu.etaxonomy.cdm.database.types;
 
+import org.hibernate.dialect.Dialect;
+import org.hibernate.dialect.SybaseDialect;
+
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 
 
@@ -28,7 +31,7 @@ public class SybaseDatabaseType extends DatabaseTypeBase {
     //port
     private int defaultPort = 4100;
     //hibernate dialect
-    private String hibernateDialect = "SybaseDialect";
+    private Dialect hibernateDialect = new SybaseDialect();
 
     private static String dbSeparator = "/";
     
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/AuditedSchemaUpdaterStepBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/AuditedSchemaUpdaterStepBase.java
new file mode 100644
index 0000000000..3eddb739d7
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/AuditedSchemaUpdaterStepBase.java
@@ -0,0 +1,38 @@
+package eu.etaxonomy.cdm.database.update;
+
+import java.sql.SQLException;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+
+public abstract class AuditedSchemaUpdaterStepBase<T extends AuditedSchemaUpdaterStepBase<T>> extends SchemaUpdaterStepBase<T> implements ISchemaUpdaterStep {
+
+	protected String tableName;
+	protected boolean includeAudTable;
+	protected boolean isAuditing;
+
+	
+	/**
+	 * Constructor
+	 * @param stepName
+	 */
+	protected AuditedSchemaUpdaterStepBase(String stepName) {
+		super(stepName);
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		boolean result = true;
+		isAuditing = false;
+		result &= invokeOnTable(tableName, datasource, monitor);
+		if (includeAudTable){
+			String aud = "_AUD";
+			isAuditing = true;
+			result &= invokeOnTable(tableName + aud, datasource, monitor);
+		}
+		return (result == true )? 0 : null;
+	}
+	
+	protected abstract boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor);
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/CdmUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/CdmUpdater.java
index 896d3f8390..b8ecdcfd2c 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/CdmUpdater.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/CdmUpdater.java
@@ -9,14 +9,16 @@
 */
 package eu.etaxonomy.cdm.database.update;
 
+import java.sql.ResultSet;
+
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.DefaultProgressMonitor;
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.CdmDataSource;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
-import eu.etaxonomy.cdm.database.update.v30_31.SchemaUpdater_30_301;
-import eu.etaxonomy.cdm.database.update.v30_31.TermUpdater_314_315;
+import eu.etaxonomy.cdm.database.update.v31_33.SchemaUpdater_31_33;
+import eu.etaxonomy.cdm.database.update.v31_33.TermUpdater_31_33;
 
 /**
  * @author a.mueller
@@ -47,31 +49,117 @@ public class CdmUpdater {
 		
 		int steps = currentSchemaUpdater.countSteps(datasource, monitor);
 		steps += currentTermUpdater.countSteps(datasource, monitor);
+		steps++;  //for hibernate_sequences update
 		
 		String taskName = "Update to schema version " + currentSchemaUpdater.getTargetVersion() + " and to term version " + currentTermUpdater.getTargetVersion(); //+ currentSchemaUpdater.getVersion();
 		monitor.beginTask(taskName, steps);
 		
 		try {
+			datasource.startTransaction();
 			result &= currentSchemaUpdater.invoke(datasource, monitor);
-			// the above apparently did not work while testing. Did not want to set the version in CdmMetaData yet
-//			result &= currentSchemaUpdater.invoke(currentSchemaUpdater.getTargetVersion(), datasource, monitor);
+			if (result == true){
+				result &= currentTermUpdater.invoke(datasource, monitor);
+				updateHibernateSequence(datasource, monitor);
+			}
+			if (result == false){
+				datasource.rollback();
+			}else{
+				datasource.commitTransaction();
+			}
 			
-			result &= currentTermUpdater.invoke(datasource, monitor);
 		} catch (Exception e) {
 			result = false;
 			monitor.warning("Stopped schema updater");
 		} finally {
 			String message = "Update finished " + (result ? "successfully" : "with ERRORS");
 			monitor.subTask(message);
-			monitor.done();
+			if (!result){
+				monitor.warning(message);
+				monitor.setCanceled(true);
+			}else{
+				monitor.done();
+			}
 			logger.info(message);
 		}
 		
 		return result;
 	}
 	
+
+	/**
+	 * Updating terms often inserts new terms, vocabularies and representations.
+	 * Therefore the counter in hibernate_sequences must be increased.
+	 * We do this once at the end of term updating.
+	 * @return true if update was successful, false otherwise
+	 */
+	private boolean updateHibernateSequence(ICdmDataSource datasource, IProgressMonitor monitor) {
+		boolean result = true;
+		monitor.subTask("Update hibernate sequences");
+		try {
+			String sql = "SELECT * FROM hibernate_sequences ";
+			ResultSet rs = datasource.executeQuery(sql);
+			while (rs.next()){
+				String table = rs.getString("sequence_name");
+				Integer val = rs.getInt("next_val");
+				result &= updateSingleValue(datasource,monitor, table, val);
+			}
+		} catch (Exception e) {
+			String message = "Exception occurred when trying to update hibernate_sequences table: " + e.getMessage();
+			monitor.warning(message, e);
+			logger.error(message);
+			result = false;
+		}finally{
+			monitor.worked(1);
+		}
+		return result;
+	}
+	
+	/**
+	 * 
+	 * @param datasource
+	 * @param monitor
+	 * @param table
+	 * @param oldVal
+	 * @return
+	 */
+	private boolean updateSingleValue(ICdmDataSource datasource, IProgressMonitor monitor, String table, Integer oldVal){
+		try {
+			Integer newVal;
+			try {
+				String sql = " SELECT max(id) FROM %s ";
+				newVal = (Integer)datasource.getSingleValue(String.format(sql, table));
+			} catch (Exception e) {
+				String message = "Could not retrieve max value for table '%s'. Will not update hibernate_sequence for this table. Usually this will not cause problems, however, if new data has been added to this table by the update script one may encounter 'unique identifier' exceptions when trying to add further data.";
+				monitor.warning(message, e);
+				//TODO
+				return true;
+			}
+			
+			//This is how {@link PooledOptimizer#generate(org.hibernate.id.enhanced.AccessCallback)} works
+			//it substracts the increment size from the value in hibernate_sequences to get the initial value.
+			//Haven't checked why.
+			//For the correct increment size see eu.etaxonomy.cdm.model.common.package-info.java
+			int incrementSize = 10;
+			newVal = newVal + incrementSize;
+			if (newVal != null && newVal >= oldVal){
+				String sql = " UPDATE hibernate_sequences " +
+						" SET next_val = %d " +
+						" WHERE sequence_name = '%s' ";
+				datasource.executeUpdate(String.format(sql, newVal + 1 , table) );
+			}
+			return true;
+		} catch (Exception e) {
+			String message = "Exception occurred when trying to read or update hibernate_sequences table for value " + table + ": " + e.getMessage();
+			monitor.warning(message, e);
+			logger.error(message);
+			return false;
+		}
+		
+	}
+	
+	
 	private ITermUpdater getCurrentTermUpdater() {
-		return TermUpdater_314_315.NewInstance();
+		return TermUpdater_31_33.NewInstance();
 	}
 
 	/**
@@ -79,7 +167,7 @@ public class CdmUpdater {
 	 * @return
 	 */
 	private ISchemaUpdater getCurrentSchemaUpdater() {
-		return SchemaUpdater_30_301.NewInstance();
+		return SchemaUpdater_31_33.NewInstance();
 	}
 
 	/**
